Buy a Ticket CodeForces - 938D Dijkstra+思维

Musicians of a popular band “Flayer” have announced that they are going to “make their exit” with a world tour. Of course, they will visit Berland as well.

There are n cities in Berland. People can travel between cities using two-directional train routes; there are exactly m routes, i-th route can be used to go from city vi to city ui (and from ui to vi), and it costs wi coins to use this route.

Each city will be visited by “Flayer”, and the cost of the concert ticket in i-th city is ai coins.

You have friends in every city of Berland, and they, knowing about your programming skills, asked you to calculate the minimum possible number of coins they have to pay to visit the concert. For every city i you have to compute the minimum number of coins a person from city i has to spend to travel to some city j (or possibly stay in city i), attend a concert there, and return to city i (if j ≠ i).

Formally, for every you have to calculate , where d(i, j) is the minimum number of coins you have to spend to travel from city i to city j. If there is no way to reach city j from city i, then we consider d(i, j) to be infinitely large.

Input
The first line contains two integers n and m (2 ≤ n ≤ 2·105, 1 ≤ m ≤ 2·105).

Then m lines follow, i-th contains three integers vi, ui and wi (1 ≤ vi, ui ≤ n, vi ≠ ui, 1 ≤ wi ≤ 1012) denoting i-th train route. There are no multiple train routes connecting the same pair of cities, that is, for each (v, u) neither extra (v, u) nor (u, v) present in input.

The next line contains n integers a1, a2, … ak (1 ≤ ai ≤ 1012) — price to attend the concert in i-th city.

Output
Print n integers. i-th of them must be equal to the minimum number of coins a person from city i has to spend to travel to some city j (or possibly stay in city i), attend a concert there, and return to city i (if j ≠ i).

Examples
Input
4 2
1 2 4
2 3 7
6 20 1 25
Output
6 14 1 25
Input
3 3
1 2 1
2 3 1
1 3 1
30 10 20
Output
12 10 12

题意:给一张图,每个点有一个点权a[i],每一条边(i,j)有一个边权b[i][j],定义一个点到到另一个点的value是,2*b[i][j]+a[j],求每一个点到其余某个点中的最小的value。

思路:这道题让你求多源最短路,但是用Floyd对于2e5的数据一定会超时,我们可以把它转化为单源最短路用 Dijkstra求解。因为是一个来回,所以我们建图时边权*2。然后我们可以按照网络流的一种思想,建立一个源点0,这个源点到各个点都有边,边(0,i)的权值为a[i],以源点为起点跑一边 Dijkstra,那么dis数组里存的就是你要的答案。

我们以第一个样例为例:

在这里插入图片描述

代码如下:

#include<cstdio>
#include<queue>
#include<cstring>
#include<algorithm>
using namespace std;
typedef long long ll;
const int maxn=400009;
struct node{
	int id;
	ll val;
	int next;
	node(){}
	node(int id,ll val):id(id),val(val){}
	friend bool operator < (node x,node y)
	{
		return x.val>y.val;
	}
}side[maxn*2];
int book[maxn],head[maxn],cnt,n,m;
ll dis[maxn];
void init()
{
	memset(head,-1,sizeof(head));
	memset(book,0,sizeof(book));
	for(int i=0;i<=n;i++)
		dis[i]=9999999999999999;
	cnt=0;
}
void add(int x,int y,ll d)
{
	side[cnt].id=y;
	side[cnt].val=d;
	side[cnt].next=head[x];
	head[x]=cnt++;
}
void dij(int sx)
{
	priority_queue<node> q;
	q.push(node(sx,0));
	dis[sx]=0;
	while(q.size())
	{
		node now=q.top();
		q.pop();
		if(book[now.id]) continue;
		book[now.id]=1;
		for(int i=head[now.id];i!=-1;i=side[i].next)
		{
			int y=side[i].id;
			if(dis[y]>dis[now.id]+side[i].val)
			{
				dis[y]=dis[now.id]+side[i].val;
				q.push(node(y,dis[y]));
			}
		}
	}
}
int main()
{
	int x,y;
	ll z;
	scanf("%d%d",&n,&m);
	init();
	for(int i=1;i<=m;i++)
	{
		scanf("%d%d%lld",&x,&y,&z);
		add(x,y,2*z);
		add(y,x,2*z);
	}
	for(int i=1;i<=n;i++)
	{
		scanf("%lld",&z);
		add(0,i,z);
	}
	dij(0);
	for(int i=1;i<=n;i++)
	{
		if(i!=1)
			printf(" ");
		printf("%lld",dis[i]);
	}
	printf("\n");
	return 0;
}

猜你喜欢

转载自blog.csdn.net/why932346109/article/details/88805699